<?php

// Taken from and simplified:
// https://wiki.archlinux.org/index.php/Awstats

$descriptorspec = array(
	array("pipe", "r"),
	array("pipe", "w"),
	array("pipe", "w"),
);

$newenv = $_SERVER;
$script = $_SERVER["X_SCRIPT_FILENAME"];
$newenv["SCRIPT_FILENAME"] = $script;
$newenv["SCRIPT_NAME"] = $_SERVER["X_SCRIPT_NAME"];

if (!is_executable($script) || is_dir($script)) {
	$err = 'Not Found';
	header("$_SERVER[SERVER_PROTOCOL] 404 $err");
	echo($err);
	error_log("$err: $script, or not allowed to execute");
	exit;
}

$process = proc_open($script, $descriptorspec, $pipes, null, $newenv);

if (!is_resource($process)) {
	$err = 'Internal Server Error';
	header("$_SERVER[SERVER_PROTOCOL] 500 $err");
	echo($err);
	error_log("$err in $script");
	exit;
}

// All ok, send response

while (true) {
	$head = fgets($pipes[1]);
	if ($head === PHP_EOL) break;
	header($head);
}
fpassthru($pipes[1]);
foreach ($pipes as $fh) fclose($fh);

proc_close($process);
